Loading...
Searching...
No Matches
BALL::GAMESSDatFile Class Reference
Molecular Modeling » File Formats » Molecular structure file formats

`#include <BALL/FORMAT/GAMESSDatFile.h>`

Inheritance diagram for BALL::GAMESSDatFile:

## Classes

class | block
struct | State

## Public Member Functions

Constructors and Destructors
| GAMESSDatFile ()
| GAMESSDatFile (const String &filename, File::OpenMode open_mode=std::ios::in)
virtual | ~GAMESSDatFile ()
Assignment.
const GAMESSDatFile & | operator= (const GAMESSDatFile &rhs)
Reading and Writing of Kernel Datastructures
virtual bool | write (const Molecule &molecule)
virtual bool | write (const System &molecule)
virtual Molecule * | read ()
virtual bool | read (System &system)
Public Member Functions inherited from BALL::GenericMolFile
| GenericMolFile ()
| GenericMolFile (const String &filename, File::OpenMode open_mode=std::ios::in)
virtual | ~GenericMolFile ()
virtual void | close ()
const GenericMolFile & | operator= (const GenericMolFile &rhs)
void | defineInputAsTemporary (bool b=true)
void | enableOutputCompression (String zipped_filename)
bool | isCompressedFile ()
virtual GenericMolFile & | operator>> (System &system)
virtual GenericMolFile & | operator<< (const System &system)
virtual GenericMolFile & | operator>> (Molecule &molecule)
virtual GenericMolFile & | operator<< (const Molecule &molecule)
Public Member Functions inherited from BALL::LineBasedFile
| LineBasedFile ()
| Default constructor.
| LineBasedFile (const String &filename, File::OpenMode open_mode=std::ios::in, bool trim_whitespaces=false)
void | clear ()
bool | operator== (const LineBasedFile &f)
bool | operator!= (const LineBasedFile &f)
const LineBasedFile & | operator= (const LineBasedFile &file)
Position | getLineNumber () const
| Get the last line number in the file.
const String & | getLine () const
| Return the current line.
String & | getLine ()
| Return the current line.
bool | readLine ()
bool | skipLines (Size number=1)
bool | search (const String &text, bool return_to_start=false)
bool | search (const String &text, const String &stop, bool return_to_start=false)
bool | gotoLine (Position line_number)
void | rewind ()
void | test (const char *file, int line, bool condition, const String &msg) const
String | getField (Index pos=0, const String &quotes="", const String &delimiters=String::CHARACTER_CLASS__WHITESPACE) const
bool | startsWith (const String &text) const
| Test if the current line starts with text.
bool | has (const String &text) const
| Return true if the current line contains text.
Index | switchString (const std::vector< String > &data) const
bool | parseColumnFormat (const char *format, Position index, Size length, void *arg)
void | enableTrimWhitespaces (bool state)
| Set wheter leading and trailing whitespaces in lines shall be removed.
bool | trimWhiteSpacesEnabled () const
Public Member Functions inherited from BALL::File
| File ()
| File (const String &name, OpenMode open_mode=std::ios::in)
virtual | ~File ()
bool | isValid () const
bool | open (const String &name, File::OpenMode open_mode=std::ios::in)
bool | reopen ()
bool | reopen (File::OpenMode open_mode)
void | close ()
const String & | getName () const
void | setName (const String &name)
const String & | getOriginalName () const
Size | getSize ()
File::OpenMode | getOpenMode () const
Type | getType (bool trace_link) const
bool | copyTo (const String &destination_name, Size buffer_size=4096)
bool | moveTo (const String &destination_name)
bool | remove ()
bool | renameTo (const String &new_path)
bool | truncate (Size size=0)
std::fstream & | getFileStream ()
TransformationManager & | getTransformationManager ()
const TransformationManager & | getTransformationManager () const
bool | operator== (const File &file) const
bool | operator!= (const File &file) const
bool | isOpen () const
bool | isClosed () const
bool | isAccessible () const
bool | isCanonized () const
bool | isReadable () const
bool | isWritable () const
bool | isExecutable () const

## Accessors

static State | state
Molecule * | molecule_
String | current_block_
StringHashMap< block > | blocks_
String | symmetry_group_
void | newMolecule ()
void | setMoleculeName (char *name)
void | insertAtom (char *element, float charge, float x, float y, float z)
void | insertBond (Index a1, Index a2)
void | inBlock (const char *blockname)
void | insertBlockedData (const char *key, const char *value)
void | insertBlockedData (const String &key, const String &value)
String & | getBlockedData (const String &block, const String &key)
const String & | getBlockedData (const String &block, const String &key) const
void | clearParameters ()
virtual void | initRead_ ()

## Additional Inherited Members

Public Types inherited from BALL::File
typedef std::ios::openmode | OpenMode
enum | Transformation { TRANSFORMATION__EXEC = 1 , TRANSFORMATION__FILTER = 2 , TRANSFORMATION__URL = 3 }
enum | Type { TYPE__UNKNOWN = 0 , TYPE__DIRECTORY = 1 , TYPE__CHAR_SPECIAL_FILE = 2 , TYPE__BLOCK_SPECIAL_FILE = 3 , TYPE__REGULAR_FILE = 4 , TYPE__SYMBOLIC_LINK = 5 , TYPE__SOCKET = 6 , TYPE__FIFO_SPECIAL_FILE = 7 }
static Size | getSize (String name)
static Type | getType (String name, bool trace_link)
static bool | copy (String source_name, String destination_name, Size buffer_size=4096)
static bool | move (const String &source_name, const String &destination_name)
static bool | remove (String name)
static bool | rename (String old_path, String new_path)
static bool | truncate (String path, Size size=0)
static bool | createTemporaryFilename (String &temporary, const String &suffix=".TMP")
static void | enableTransformation (Transformation transformation)
static void | disableTransformation (Transformation transformation)
static bool | isTransformationEnabled (Transformation transformation)
static void | registerTransformation (const String &pattern, const String &exec)
static void | unregisterTransformation (const String &pattern)
static bool | isAccessible (String name)
static bool | isReadable (String name)
static bool | isWritable (String name)
static bool | isExecutable (String name)
Static Public Attributes inherited from BALL::File
static const OpenMode | MODE_IN
| Open for input (default).
static const OpenMode | MODE_OUT
| Open for output.
static const OpenMode | MODE_APP
| Append. Seek to end before each write operation.
static const OpenMode | MODE_BINARY
| Binary mode.
static const OpenMode | MODE_ATE
| Seek to end directly after opening.
static const OpenMode | MODE_TRUNC
| Truncate an existing file.
static const String | TRANSFORMATION_EXEC_PREFIX
| Prefix for filenames that are created through the execution of commands "exec:".
static const String | TRANSFORMATION_FILE_PREFIX
| Prefix for files (to mimick URL-like behavior) "file:".
static const String | TRANSFORMATION_FTP_PREFIX
| Prefix for FTP-transfers "ftp://".
static const String | TRANSFORMATION_HTTP_PREFIX
| Prefix for HTTP-transfer "http://".
virtual void | initWrite_ ()
bool | input_is_temporary_
bool | compress_output_
bool | gmf_is_closed_
String | zipped_filename_
String | line_
| buffer for the line in use
Position | line_number_
| line number in the file
bool | trim_whitespaces_
vector< char > | col_buffer_
| buffer for column parsing
String | name_
String | original_name_
OpenMode | open_mode_
bool | is_open_
bool | is_temporary_
static HashSet< String > | created_temp_filenames_
static TransformationManager | transformation_manager_
static Size | transformation_methods_

## Detailed Description

GAMESSDat file class. This class enables BALL to read and write input and output .dat files for the GAMESS quantum chemistry application.

Definition at line 23 of file GAMESSDatFile.h.

## Constructor & Destructor Documentation

## GAMESSDatFile() [1/2]

BALL::GAMESSDatFile::GAMESSDatFile | ( |  | ) |

Default constructor

## GAMESSDatFile() [2/2]

BALL::GAMESSDatFile::GAMESSDatFile | ( | const String & | filename,
|  | File::OpenMode | open_mode = std::ios::in )

Detailed constructor

Exceptions

  Exception::FileNotFound | if the file could not be opened

## ~GAMESSDatFile()

virtual BALL::GAMESSDatFile::~GAMESSDatFile | ( |  | ) |

virtual

Destructor

## Member Function Documentation

## clearParameters()

void BALL::GAMESSDatFile::clearParameters | ( |  | ) |

## getBlockedData() [1/2]

String & BALL::GAMESSDatFile::getBlockedData | ( | const String & | block,
|  | const String & | key )

## getBlockedData() [2/2]

const String & BALL::GAMESSDatFile::getBlockedData | ( | const String & | block,
|  | const String & | key ) const

## inBlock()

void BALL::GAMESSDatFile::inBlock | ( | const char * | blockname | ) |

## initRead_()

virtual void BALL::GAMESSDatFile::initRead_ | ( |  | ) |

protected virtual

Initialize internals for read. This method is called by the default implementation of read(System& system) . Its purpose is the initialization of internal members holding, for example, header information from the file. The default implementation provided is empty.

Reimplemented from BALL::GenericMolFile.

## insertAtom()

void BALL::GAMESSDatFile::insertAtom | ( | char * | element,
|  | float | charge,
|  | float | x,
|  | float | y,
|  | float | z )

## insertBlockedData() [1/2]

void BALL::GAMESSDatFile::insertBlockedData | ( | const char * | key,
|  | const char * | value )

## insertBlockedData() [2/2]

void BALL::GAMESSDatFile::insertBlockedData | ( | const String & | key,
|  | const String & | value )

## insertBond()

void BALL::GAMESSDatFile::insertBond | ( | Index | a1,
|  | Index | a2 )

## newMolecule()

void BALL::GAMESSDatFile::newMolecule | ( |  | ) |

## operator=()

const GAMESSDatFile & BALL::GAMESSDatFile::operator= | ( | const GAMESSDatFile & | rhs | ) |

Assignment operator. Create a new object pointing to the same filename.

Exceptions

  Exception::FileNotFound | if the file could not be opened

## read() [1/2]

virtual Molecule * BALL::GAMESSDatFile::read | ( |  | ) |

virtual

Read a Molecule from the GAMESSDatFile. If the GAMESS .dat - file contains additional lines apart from the molecule itself, they are stored in this class.

Exceptions

  Exception::ParseError | if a syntax error was encountered

Reimplemented from BALL::GenericMolFile.

## read() [2/2]

virtual bool BALL::GAMESSDatFile::read | ( | System & | system | ) |

virtual

Read a System from the GAMESSDatFile. If the GAMESS .dat - file contains additional lines apart from the molecule itself, they are stored in this class.

Exceptions

  Exception::ParseError | if a syntax error was encountered

Reimplemented from BALL::GenericMolFile.

## setMoleculeName()

void BALL::GAMESSDatFile::setMoleculeName | ( | char * | name | ) |

## write() [1/2]

virtual bool BALL::GAMESSDatFile::write | ( | const Molecule & | molecule | ) |

virtual

Write a molecule to a GAMESSDatFile. If additional GAMESS - keywords are stored in this class, they will be written as well.

Exceptions

  File::CannotWrite | if writing to the file failed

Reimplemented from BALL::GenericMolFile.

## write() [2/2]

virtual bool BALL::GAMESSDatFile::write | ( | const System & | molecule | ) |

virtual

Write a system to a GAMESSDatFile. If additional GAMESS - keywords are stored in this class, they will be written as well.

Exceptions

  File::CannotWrite | if writing to the file failed

Reimplemented from BALL::GenericMolFile.

## Member Data Documentation

## blocks_

StringHashMap<block> BALL::GAMESSDatFile::blocks_

protected

Definition at line 143 of file GAMESSDatFile.h.

## current_block_

String BALL::GAMESSDatFile::current_block_

protected

Definition at line 142 of file GAMESSDatFile.h.

## molecule_

Molecule* BALL::GAMESSDatFile::molecule_

protected

Definition at line 140 of file GAMESSDatFile.h.

## state

State BALL::GAMESSDatFile::state

static

Definition at line 135 of file GAMESSDatFile.h.

## symmetry_group_

String BALL::GAMESSDatFile::symmetry_group_

protected

Definition at line 144 of file GAMESSDatFile.h.